.\" @(#)compressHelp (C) F. Thomas and M. Brouwer
.\" 
.TH COMPRESSHELP 1 "Local (Apr 1993)"
.SH NAME
compressHelp \- compress help directory to one file for NeXT's help system.
.SH SYNOPSIS
.B compressHelp
[
.B \-d \-h \-n \-v \-V
] helpDirectory [directory ..]

.SH DESCRIPTION
.I compressHelp 
is not restricted to be used on help directories but only useful for these. 
.I compressHelp
writes the file it produces to the parent directory of
.IR helpDirectory .
So
.RI ` "compressHelp " test/Help'
produces a file 
.IR test/Help .store.
.I compressHelp
doesn't delete your help directory although it's not needed anymore for the application. 
But as I don't ship 
.I uncompressHelp
it would be impossible to make any changes. The output file should be compatible to the help directory. If it's not send email to
.br
`frank@glocke.robin.de (Frank Thomas)'.
 
.SH OPTIONS
.PP
.TP 8
.B \-d
Delete directory after successful creation of .store file.  Useful from within a Makefile.postamble.
.TP
.B \-h
Show all options of 
.IR compressHelp .
.TP
.B \-n
Don't print warnings for unrecognized files. Normally it prints a warning for all non regular files like symlinks and devices.
.TP
.B \-v
Verbose mode. Shows what the program is doing. 
.TP
.B \-V
Print version number.

.SH "SEE ALSO"
.IR duplink (1), " duplink.info"
.SH DIAGNOSTICS
.I CompressHelp
only knows how to handle 
.IR .rtf , " .rtfd " and " .index.store " files.
If 
.I compressHelp
finds some files that it doesn't know how to handle, the message `Unknown filetype 
.IR name '
is ommited. 

.SH AUTHOR
Frank Thomas <frank@glocke.robin.de>
.SH THANKS
To Michael Brouwer who wrote 
.IR duplink ,
added all options to 
.I compressHelp
and pushed me to continue to work on 
.IR compressHelp .
